<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';
import { SlpPlayIcon } from '../index.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

interface Author {
  name: string;
  title: string;
  company: {
    name: string;
    url: string;
  };
}

interface Hero {
  header: string;
  quote: string;
  subheader: string;
  video?: {
    image: string;
    url: string;
  };
  image?: {
    src: string;
    alt: string;
  };
  icon?: string;
  author: Author;
}

interface Card {
  icon: string;
  name: string;
  description: string;
  href: string;
}

interface CTA {
  icon?: string;
  text: string;
  primaryButton: {
    text: string;
    href: string;
  };
  secondaryButton: {
    text: string;
    href: string;
  };
}

export default Vue.extend({
  components: {
    SlpPlayIcon,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    hero: {
      type: Object as PropType<Hero>,
      required: true,
    },
    cards: {
      type: Array as PropType<Card[]>,
      required: true,
    },
    cta: {
      type: Object as PropType<CTA>,
      required: true,
    },
  },
  data() {
    return {
      modal: {
        open: false,
      },
    };
  },
  methods: {
    openModal() {
      this.modal.open = true;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
    },
    closeModal() {
      this.modal.open = false;
    },
  },
});
</script>

<template>
  <div class="by-company-size-container">
    <div class="hero">
      <div class="text">
        <SlpIcon
          :name="hero.icon || 'increase-thin'"
          variant="marketing"
          size="md"
        />
        <SlpTypography variant="body3">{{ hero.subheader }}</SlpTypography>
        <SlpTypography variant="heading3-bold" class="header">
          {{ hero.header }}
        </SlpTypography>
        <SlpIcon
          name="quote"
          variant="marketing"
          size="md"
          class="quote-icon"
        />
        <SlpTypography variant="quotes" class="quote">
          {{ hero.quote }}</SlpTypography
        >
        <div class="author">
          <SlpTypography variant="body2-bold"
            >{{ hero.author.name }}, {{ hero.author.title }},
            <a
              :href="hero.author.company.url"
              class="company-link"
              :data-ga-name="hero.author.company.name"
              data-ga-location="by company"
            >
              {{ hero.author.company.name }}
            </a></SlpTypography
          >
        </div>
      </div>

      <div
        class="image__container"
        :style="{ background: `url(${hero.video?.image})` }"
        @click="openModal"
      >
        <div class="image__container--play">
          <SlpPlayIcon />
        </div>
      </div>
    </div>
    <div class="card-grid">
      <a
        v-for="card in cards"
        :key="card.name"
        class="card"
        :href="card.href"
        :data-ga-name="card.name"
        data-ga-location="by company"
      >
        <SlpIcon :name="card.icon" size="md" variant="marketing" />
        <SlpTypography variant="heading5-bold">{{ card.name }}</SlpTypography>
        <SlpTypography variant="body3">{{ card.description }}</SlpTypography>
        <SlpIcon name="arrow-right" variant="product" size="sm" />
      </a>
      <div class="cta">
        <div class="text">
          <SlpIcon
            :name="cta.icon || 'pricing-plans'"
            variant="marketing"
            size="md"
          />
          <SlpTypography variant="heading4-bold"> {{ cta.text }}</SlpTypography>
        </div>
        <div class="buttons">
          <SlpButton
            :href="cta.primaryButton.href"
            class="primary gleam"
            data-ga-name="ultimate"
            data-ga-location="by company"
            >{{ cta.primaryButton.text }}
            <SlpIcon name="arrow-right" variant="product" size="sm" />
          </SlpButton>
          <SlpButton
            :href="cta.secondaryButton.href"
            class="secondary"
            data-ga-name="premium"
            data-ga-location="by company"
          >
            {{ cta.secondaryButton.text }}
            <SlpIcon name="arrow-right" variant="product" size="sm" />
          </SlpButton>
        </div>
      </div>
    </div>
    <SolutionsVideoModal
      v-show="modal.open"
      light-background
      :visible="modal.open"
      @close="closeModal"
    >
      <template #body>
        <lite-vimeo
          :videoid="getVimeoVideoId(createVideoSource(hero.video?.url))"
          title="Video"
          autoplay
        ></lite-vimeo>
      </template>
    </SolutionsVideoModal>
  </div>
</template>

<style lang="scss" scoped>
.by-company-size-container {
  background: $color-surface-800;
  padding: 16px;
  margin: 96px 0;
  border-radius: 8px;

  @media (min-width: $breakpoint-lg) {
    padding: 48px;
  }

  .hero {
    display: flex;
    flex-direction: column;
    align-items: center;
    @media (min-width: $breakpoint-lg) {
      flex-direction: row;
    }
    .header {
      @media (max-width: $breakpoint-lg) {
        font-size: 28px !important;
        line-height: 36px !important;
      }
    }
    .text {
      max-width: 60%;
      display: flex;
      flex-direction: column;
      gap: 16px;
      .quote {
        font-size: 16px !important;
        line-height: 24px !important;
      }
      .quote,
      .quote-icon,
      .author {
        @media (max-width: $breakpoint-lg) {
          display: none;
        }
      }
    }
    /*
    .image-container {
      img {
        border-radius: 4px 4px 120px 4px;
        max-width: 100%;
        margin-top: 16px;
        @media (min-width: $breakpoint-lg) {
          margin-top: 0;
          max-width: unset;
          position: relative;
          right: -120px;
          width: 460px;
          height: 360px;
        }
      }
    }*/
    lite-vimeo {
      height: 315px;
      width: 560px;
    }
    .image__container {
      margin: 0 $spacing-16;
      height: 281px;
      width: 100%;
      flex-basis: 50%;
      position: relative;
      border-bottom-right-radius: 160px;
      @media (max-width: $breakpoint-lg) {
        min-height: 300px;
      }
      @media (min-width: $breakpoint-lg) {
        max-width: 50%;
      }

      &:hover {
        .image__container--play {
          opacity: 1;
        }
      }

      &--play {
        position: absolute;
        top: 40%;
        right: 45%;
        opacity: 0.75;
        transition: all 0.3s;
      }
      img {
        min-height: 100%;
        object-fit: cover;
        @media (max-width: $breakpoint-md) {
          width: 100%;
          min-height: initial;
        }
      }
    }
  }
  .card-grid {
    display: grid;
    grid-template-columns: 1fr;
    margin-top: 48px;
    gap: 40px 24px;
    @media (min-width: $breakpoint-lg) {
      grid-template-columns: 1fr 1fr 1fr;
    }
    .card {
      cursor: pointer;
      display: flex;
      background: white;
      color: $color-text-300;
      border-radius: 4px;
      flex-direction: column;
      gap: 16px;
      padding: 24px;
      transition: all 0.3s;
      &:hover {
        border-radius: 4px 4px 90px 4px;
      }
    }
    .cta {
      background: white;
      display: flex;
      padding: 24px;
      border-radius: 4px;
      align-items: center;
      flex-direction: column;
      justify-content: space-between;
      gap: 16px;
      @media (min-width: $breakpoint-lg) {
        gap: 0;
        padding: 32px 48px;
        grid-column: span 3;
        flex-direction: row;
      }
      .text,
      .buttons {
        display: flex;
        flex-direction: column;
        @media (max-width: $breakpoint-lg) {
          width: 100%;
        }
      }
      .text {
        gap: 16px;
        flex: 0.8;
      }
      .buttons {
        gap: 8px;
        .primary,
        .secondary {
          border: none;
          display: flex;
          justify-content: space-between;
          transition: all 0.3s;
          @media (min-width: $breakpoint-lg) {
            min-width: 230px;
          }
        }
        .primary {
          color: $color-text-300;
          background: linear-gradient(90.25deg, #e3d6ff 0.05%, #ffcccc 115.41%);

          &.gleam {
            background: linear-gradient(
              93.83deg,
              rgba(199, 177, 254, 0.75) 7.27%,
              rgba(255, 212, 216, 0.75) 105.33%
            ) !important;
            color: $color-primary-200 !important;
            border: none !important;
            position: relative;
            overflow: hidden;

            &:after {
              content: '';
              position: absolute;
              top: 0;
              left: -200%;
              width: 200%;
              height: 100%;
              transform: skewX(-20deg);
              background-image: linear-gradient(
                to right,
                transparent,
                rgba(255, 255, 255, 0.5),
                transparent
              );
            }

            &:hover:after {
              animation: shine 0.8s ease-in-out;
            }
          }
        }
        .secondary {
          background: $color-surface-900;
          color: $color-text-300;
          &:hover {
            background: $color-surface-950;
          }
        }
      }
    }
  }
}
@keyframes shine {
  100% {
    left: 200%;
  }
}
</style>
